package cn.com.infosec.mobile.android.algorithm;

import android.util.Base64;
import java.util.Arrays;

public class SM4 {
   private byte[] addPadding(byte[] buf, int blockSize) {
      int var3;
      if ((var3 = buf.length + 1) % blockSize != 0) {
         var3 = var3 + (blockSize - 1) - (var3 + (blockSize - 1)) % blockSize;
      }

      int var10000 = var3;
      byte var4 = (byte)(var3 - buf.length);
      byte[] blockSize1;
      byte[] var6 = blockSize1 = new byte[var10000];
      Arrays.fill(blockSize1, var4);
      var3 = buf.length;
      System.arraycopy(buf, 0, blockSize1, 0, var3);
      return var6;
   }

   private byte[] removePadding(byte[] buf) {
      byte var2 = buf[buf.length - 1];
      return Arrays.copyOfRange(buf, 0, buf.length - var2);
   }

   public byte[] generateSecretKey(byte[] seed) {
      return seed != null && seed.length > 0 ? this.genKey() : null;
   }

   public String encrypt(byte[] secretKey, byte[] iv, byte[] plain, int mode) {
      if (secretKey != null && plain != null && secretKey.length == 16 && plain.length > 0) {
         if (1 == mode && (iv == null || iv.length != 16)) {
            return null;
         } else {
            byte[] var5;
            if (1 == mode) {
               var5 = this.encryptCBC(plain, secretKey, iv);
            } else {
               var5 = this.encryptECB(plain, secretKey);
            }

            return var5 != null ? Base64.encodeToString(var5, 2) : null;
         }
      } else {
         return null;
      }
   }

   public byte[] decrypt(byte[] secretKey, byte[] iv, byte[] encryptBytes, int mode) {
      if (secretKey != null && encryptBytes != null && secretKey.length == 16 && encryptBytes.length > 0) {
         if (1 == mode && (iv == null || iv.length != 16)) {
            return null;
         } else {
            return 1 == mode ? this.decryptCBC(encryptBytes, secretKey, iv) : this.decryptECB(encryptBytes, secretKey);
         }
      } else {
         return null;
      }
   }

   public byte[] genKey() {
      return new byte[]{52, -42, -17, -5, -43, -67, -57, -56, 2, 15, 97, -101, -3, -125, 3, -75};
   }

   public byte[] encryptECB(byte[] plain, byte[] key) {
      return plain != null && plain.length > 0 && key != null && key.length == 16 ? cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM4.sm4_ecb_encrypt(plain, key) : null;
   }

   public byte[] decryptECB(byte[] cipher, byte[] key) {
      return cipher != null && cipher.length > 0 && key != null && key.length == 16 ? cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM4.sm4_ecb_decrypt(cipher, key) : null;
   }

   public byte[] encryptCBC(byte[] plain, byte[] key, byte[] iv) {
      return plain != null && plain.length > 0 && key != null && key.length == 16 && iv != null && iv.length == 16 ? cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM4.sm4_cbc_encrypt(this.addPadding(plain, 16), key, iv) : null;
   }

   public byte[] decryptCBC(byte[] cipher, byte[] key, byte[] iv) {
      return cipher != null && cipher.length > 0 && key != null && key.length == 16 && iv != null && iv.length == 16 ? this.removePadding(cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM4.sm4_cbc_decrypt(cipher, key, iv)) : null;
   }
}
